#!/bin/bash
PHP_VERSION=$1 # Without dot
COMPOSER_VERSION=$2

if [[ -z "${PHP_VERSION}" ]]; then PHP_VERSION=74; fi

CONTAINER=$(docker ps | grep workspace${PHP_VERSION} | awk '{print $1}')

if [[ -z "${CONTAINER}" ]]; then
  echo "Unable to find container: workspace${PHP_VERSION}"
  exit 1
fi

if [[ -z "${COMPOSER_VERSION}" ]]; then
  COMPOSER_VERSION=1
fi

docker exec -ti "${CONTAINER}" composer self-update --${COMPOSER_VERSION}
